# coding: utf-8

import math
import kivy
from kivy.app import App
from kivy.lang import Builder
from kivy.uix.floatlayout import FloatLayout
from kivy.core.window import Window
from kivy.clock import Clock
from kivy.uix.slider import Slider
from kivy.properties import BooleanProperty
from kivy.properties import NumericProperty
from kivy.properties import ConfigParser, ObjectProperty, StringProperty ,BooleanProperty

pose_ =[]
pose_ = 10 * [0]
roll_=0
ROLL = 0
PITCH = 0
YAW = 0

class Get:
    def get_Pose(self):#ROLL PITCH YAW　データをＲＴＣ側へ
        global ROLL,PITCH,YAW
	data_=[]
	data_=10*[0]
	data_[0]=math.radians(ROLL)
	data_[1]=math.radians(PITCH)
	data_[2]=math.radians(YAW)
        return data_#data_[10]
        
class RootWidget(FloatLayout):
    Label_ROLL=0
    
    str_ROLL= StringProperty('0.000')  #ＲＯＬＬ 表示用Ｓｔｒｉｎｇ　
    str_PITCH= StringProperty('0.000') #PITCH 表示用Ｓｔｒｉｎｇ
    str_YAW= StringProperty('0.000') #YAW 表示用Ｓｔｒｉｎｇ
    S1_Value=0 #ROLLSlider
    S2_Value=0 #PITCHSlider
    S3_Value=0 #YAWSlider
    
    def __init__(self, **kwargs):
        super(RootWidget, self).__init__(**kwargs)
        global S1,S2,S3
        Clock.schedule_interval(self.my_callback, 1/1000.)
        S1=Slider(min=-180,max=180, orientation='vertical',size_hint=(None, .7), pos_hint={'x': .09,'y': .2} )
        S1.bind(value=self._set_Slider1)#S1S;iderの値をself.S1_Valueへ
        self.add_widget(S1)
        S2=Slider(min=-180,max=180, orientation='vertical',size_hint=(None, .7), pos_hint={'x': .4,'y': .2} )
        S2.bind(value=self._set_Slider2)#S2S;iderの値をself.S2_Valueへ
        self.add_widget(S2)
        S3=Slider(min=0,max=360, orientation='vertical',size_hint=(None, .7), pos_hint={'x': .7,'y': .2} )
        S3.bind(value=self._set_Slider3)#S3S;iderの値をself.S3_Valueへ
        self.add_widget(S3)
        
        #self.sr.bind(value=self.ROLL)
        
       # print 'abnormalize'
    
    def _set_Slider1(self, instance, value):
        self.S1_Value = value#S1S;iderの値をself.S1_Valueへ
                   
    def _set_Slider2(self, instance, value):
        self.S2_Value = value#S2S;iderの値をself.S2_Valueへ
                   
    def _set_Slider3(self, instance, value):
        self.S3_Value = value#S3S;iderの値をself.S3_Valueへ
                   
    def on_touch_down(self, touch):
        super(RootWidget, self).on_touch_down(touch)
	#print "Touch_Down!"   ,touch.pos
	if touch.is_double_tap:
	        pass
        #    print('Touch is a double tap !')
        #    print(' - interval is', touch.double_tap_time)
        #    print(' - distance between previous is', touch.double_tap_distance)
        pass
        
    def on_touch_up(self, touch):
        super(RootWidget, self).on_touch_up(touch)
	#print "Touch_Up!"
	pass
    
    def on_touch_move(self, touch):
        super(RootWidget, self).on_touch_move(touch)
        #print touch.pos
        pass
        
    def my_callback(self,dt):
        global pose_,ROLL,PITCH,YAW
        #ROLLにＳ１の値代入　表示用ｓｔｒへ
        ROLL = self.S1_Value
        self.str_ROLL = self.str_kMGTP(ROLL,0)
        #ＰＩＴＣＨにＳ２の値代入　表示用ｓｔｒへ
        PITCH = self.S2_Value
        self.str_PITCH = self.str_kMGTP(PITCH,0)
        #YAWにＳ１の値代入　表示用ｓｔｒへ
        YAW = self.S3_Value
        self.str_YAW = self.str_kMGTP(YAW,0)
       # print"------------------------------------------------"
   #     print self.ids.SL_R.value ," ", self.sp.value ," ", self.sy.value 
      #  print"RPY"
       # print self.S1_Value ,self.S2_Value ,self.S3_Value ,self.str_ROLL
       # print ROLL," ",PITCH," ",YAW
       # print"------------------------------------------------"
        pass
        
    def reset(self):#resetボタン　すべて０に
        global S1,S2,S3
        self.S1_Value =0
        self.S2_Value =0
        self.S3_Value =0
        
        #スライダー削除後再度生成　Ｓ１
        self.remove_widget(S1)
        S1=Slider(min=-180,max=180, orientation='vertical',size_hint=(None, .7), pos_hint={'x': .09,'y': .2} )
        S1.bind(value=self._set_Slider1)
        self.add_widget(S1)
        
        #スライダー削除後再度生成　Ｓ２
        self.remove_widget(S2)
        S2=Slider(min=-180,max=180, orientation='vertical',size_hint=(None, .7), pos_hint={'x': .4,'y': .2} )
        S2.bind(value=self._set_Slider2)
        self.add_widget(S2)
        
        
        #スライダー削除後再度生成　Ｓ３
        self.remove_widget(S3)
        S3=Slider(min=0,max=360, orientation='vertical',size_hint=(None, .7), pos_hint={'x': .7,'y': .2} )
        S3.bind(value=self._set_Slider3)
        self.add_widget(S3)
        
        pass

##################################################################################
# kilo mega giga tera peta  & DEG ⇔ RAD
##################################################################################        
    def str_kMGTP(self,data,m_deg):
        global Slider_Val
        global X_VAL
        if(m_deg==0):
            str_kMGTP_ = '%.3f' %  float(data)
            #print "Position" 
        elif(m_deg==1):
            if CONF_FLGS[2]==0:
                str_kMGTP_ = '%.3f' %  float(data)
            if CONF_FLGS[2]==1:
                str_kMGTP_ = '%.3f' %  float( math.degrees(data) )
            if CONF_FLGS[2]==2:
                str_kMGTP_ = '%.3f' %  float( math.radians(data) )
        else :
            str_kMGTP_ = '%.3f' %  float(data)
                
            #print "Orientation"
        #k
        if math.fabs(float(data))>10000:#kのみ10Kからk付きの表記
            str_kMGTP_ = '%.3fk' % float( float(data)/1000)
        #M 使わない？
        if math.fabs(float(data))>1000000:
            str_kMGTP_ = '%.3fM' % float( float(data)/1000000)
        #G 使わない？
        if math.fabs(float(data))>1000000000:
            str_kMGTP_ = '%.3fG' % float( float(data)/1000000000)
        #T 使わない？
        if math.fabs(float(data))>1000000000000:
            str_kMGTP_ = '%.3fG' % float( float(data)/1000000000000)
        #P 使わない
        if math.fabs(float(data))>1000000000000000:
            str_kMGTP_ = '%.3fG' % float( float(data)/1000000000000000)
        return str_kMGTP_
##################################################################################


class dummy_poseApp(App):
    def build(self):
       # self.root=RootWidget()
        Window.size = (400,450)
        return RootWidget()
        
        
if  __name__ == '__main__':dummy_poseApp().run()
